# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from togai_client.models.add_on_type import AddOnType
from typing import Optional, Set
from typing_extensions import Self

class AddOn(BaseModel):
    """
    AddOn
    """ # noqa: E501
    name: Annotated[str, Field(strict=True, max_length=255)] = Field(description="Name of addon")
    type: AddOnType
    billable_name: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Billable name of addon. Billable name takes precedence over name to display in invoice.", alias="billableName")
    id: StrictStr = Field(description="Id of addon")
    created_at: datetime = Field(description="Created Time of addon", alias="createdAt")
    status: StrictStr = Field(description="status of addon")
    display_name: StrictStr = Field(description="Display name of addon. This is an auto-generated field which contains billableName of addon. If billableName is not provided, name will be used as display name. ", alias="displayName")
    __properties: ClassVar[List[str]] = ["name", "type", "billableName", "id", "createdAt", "status", "displayName"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['ACTIVE', 'ARCHIVED']):
            raise ValueError("must be one of enum values ('ACTIVE', 'ARCHIVED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddOn from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddOn from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "type": obj.get("type"),
            "billableName": obj.get("billableName"),
            "id": obj.get("id"),
            "createdAt": obj.get("createdAt"),
            "status": obj.get("status"),
            "displayName": obj.get("displayName")
        })
        return _obj


