# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AlertTemplate(BaseModel):
    """
    AlertTemplate
    """ # noqa: E501
    id: StrictStr = Field(description="Alert Template ID")
    name: StrictStr = Field(description="Alert Template Name")
    description: Optional[StrictStr] = Field(default=None, description="Alert Template Description")
    interval: StrictInt = Field(description="Cron Interval")
    entity_schema: Optional[StrictStr] = Field(default=None, description="Entity Schema", alias="entitySchema")
    entity_type: Optional[StrictStr] = Field(default=None, description="Entity Type", alias="entityType")
    owner_schema: Optional[StrictStr] = Field(default=None, description="Owner Schema", alias="ownerSchema")
    owner_type: Optional[StrictStr] = Field(default=None, description="Owner Type", alias="ownerType")
    parameters_schema: Optional[StrictStr] = Field(default=None, description="Parameters Schema", alias="parametersSchema")
    created_at: datetime = Field(description="Created At", alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, description="Updated At", alias="updatedAt")
    __properties: ClassVar[List[str]] = ["id", "name", "description", "interval", "entitySchema", "entityType", "ownerSchema", "ownerType", "parametersSchema", "createdAt", "updatedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AlertTemplate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AlertTemplate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "interval": obj.get("interval"),
            "entitySchema": obj.get("entitySchema"),
            "entityType": obj.get("entityType"),
            "ownerSchema": obj.get("ownerSchema"),
            "ownerType": obj.get("ownerType"),
            "parametersSchema": obj.get("parametersSchema"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt")
        })
        return _obj


