# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CreateCustomerContactRequest(BaseModel):
    """
    Payload to create a contact for a customer
    """ # noqa: E501
    preferred_username: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, alias="preferredUsername")
    name: Annotated[str, Field(strict=True, max_length=50)]
    password: Optional[Annotated[str, Field(strict=True, max_length=100)]] = None
    email: Annotated[str, Field(strict=True, max_length=320)]
    phone: Optional[Annotated[str, Field(strict=True, max_length=30)]] = None
    verified: Optional[StrictBool] = None
    login_access: Optional[StrictBool] = Field(default=False, alias="loginAccess")
    __properties: ClassVar[List[str]] = ["preferredUsername", "name", "password", "email", "phone", "verified", "loginAccess"]

    @field_validator('preferred_username')
    def preferred_username_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Za-z0-9]{3,50}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Za-z0-9]{3,50}$/")
        return value

    @field_validator('email')
    def email_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^\S+@\S+\.\S+$", value):
            raise ValueError(r"must validate the regular expression /^\S+@\S+\.\S+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCustomerContactRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCustomerContactRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "preferredUsername": obj.get("preferredUsername"),
            "name": obj.get("name"),
            "password": obj.get("password"),
            "email": obj.get("email"),
            "phone": obj.get("phone"),
            "verified": obj.get("verified"),
            "loginAccess": obj.get("loginAccess") if obj.get("loginAccess") is not None else False
        })
        return _obj


