# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from togai_client.models.account import Account
from togai_client.models.address import Address
from togai_client.models.create_entity_setting import CreateEntitySetting
from typing import Optional, Set
from typing_extensions import Self

class CreateCustomerResponse(BaseModel):
    """
    CreateCustomerResponse
    """ # noqa: E501
    id: Annotated[str, Field(strict=True, max_length=50)] = Field(description="Identifier of customer")
    togai_customer_id: StrictStr = Field(description="Unique identifier of customer", alias="togaiCustomerId")
    name: Annotated[str, Field(min_length=3, strict=True, max_length=255)] = Field(description="Name of the Customer")
    primary_email: Annotated[str, Field(strict=True, max_length=320)] = Field(description="Primary email of the customer", alias="primaryEmail")
    billing_address: Optional[StrictStr] = Field(default=None, alias="billingAddress")
    address: Optional[Address] = None
    settings: Optional[Annotated[List[CreateEntitySetting], Field(min_length=0, max_length=10)]] = None
    account: Optional[Account] = None
    __properties: ClassVar[List[str]] = ["id", "togaiCustomerId", "name", "primaryEmail", "billingAddress", "address", "settings", "account"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCustomerResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in settings (list)
        _items = []
        if self.settings:
            for _item_settings in self.settings:
                if _item_settings:
                    _items.append(_item_settings.to_dict())
            _dict['settings'] = _items
        # override the default output from pydantic by calling `to_dict()` of account
        if self.account:
            _dict['account'] = self.account.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCustomerResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "togaiCustomerId": obj.get("togaiCustomerId"),
            "name": obj.get("name"),
            "primaryEmail": obj.get("primaryEmail"),
            "billingAddress": obj.get("billingAddress"),
            "address": Address.from_dict(obj["address"]) if obj.get("address") is not None else None,
            "settings": [CreateEntitySetting.from_dict(_item) for _item in obj["settings"]] if obj.get("settings") is not None else None,
            "account": Account.from_dict(obj["account"]) if obj.get("account") is not None else None
        })
        return _obj


