# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from togai_client.models.dimensions_schema import DimensionsSchema
from togai_client.models.enrichments import Enrichments
from togai_client.models.event_attribute_schema import EventAttributeSchema
from typing import Optional, Set
from typing_extensions import Self

class CreateEventSchemaRequest(BaseModel):
    """
    Request to create event schema
    """ # noqa: E501
    name: Annotated[str, Field(strict=True, max_length=50)] = Field(description="Name of the event. Must be unique for an organization.")
    description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Description of the event")
    attributes: Annotated[List[EventAttributeSchema], Field(max_length=50)]
    dimensions: Annotated[List[DimensionsSchema], Field(max_length=50)]
    enrichments: Optional[Enrichments] = None
    filter_fields: Optional[List[StrictStr]] = Field(default=None, description="List of fields that can be used for filtering in usage meter", alias="filterFields")
    event_id_template: Optional[StrictStr] = Field(default=None, description="Template used to generate event id based on event payload", alias="eventIdTemplate")
    __properties: ClassVar[List[str]] = ["name", "description", "attributes", "dimensions", "enrichments", "filterFields", "eventIdTemplate"]

    @field_validator('name')
    def name_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[\sa-zA-Z0-9_-]*$", value):
            raise ValueError(r"must validate the regular expression /^[\sa-zA-Z0-9_-]*$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateEventSchemaRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in attributes (list)
        _items = []
        if self.attributes:
            for _item_attributes in self.attributes:
                if _item_attributes:
                    _items.append(_item_attributes.to_dict())
            _dict['attributes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in dimensions (list)
        _items = []
        if self.dimensions:
            for _item_dimensions in self.dimensions:
                if _item_dimensions:
                    _items.append(_item_dimensions.to_dict())
            _dict['dimensions'] = _items
        # override the default output from pydantic by calling `to_dict()` of enrichments
        if self.enrichments:
            _dict['enrichments'] = self.enrichments.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateEventSchemaRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "attributes": [EventAttributeSchema.from_dict(_item) for _item in obj["attributes"]] if obj.get("attributes") is not None else None,
            "dimensions": [DimensionsSchema.from_dict(_item) for _item in obj["dimensions"]] if obj.get("dimensions") is not None else None,
            "enrichments": Enrichments.from_dict(obj["enrichments"]) if obj.get("enrichments") is not None else None,
            "filterFields": obj.get("filterFields"),
            "eventIdTemplate": obj.get("eventIdTemplate")
        })
        return _obj


