# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from togai_client.models.credit_grant_type import CreditGrantType
from togai_client.models.credit_rate_details import CreditRateDetails
from togai_client.models.grant_details import GrantDetails
from togai_client.models.invoice_timing import InvoiceTiming
from togai_client.models.recurrence_config import RecurrenceConfig
from typing import Optional, Set
from typing_extensions import Self

class CreditGrantRateCard(BaseModel):
    """
    Credit grant rate card
    """ # noqa: E501
    id: StrictStr
    display_name: Optional[StrictStr] = Field(default=None, alias="displayName")
    name: Optional[StrictStr] = Field(default=None, description="Unique identifier for the rate card in a price plan. If left null it is auto-generated.")
    tag: Optional[StrictStr] = Field(default=None, description="A tag string to group creditGrantRateCard")
    grant_details: GrantDetails = Field(alias="grantDetails")
    rate_details: CreditRateDetails = Field(alias="rateDetails")
    invoice_timing: Optional[InvoiceTiming] = Field(default=None, alias="invoiceTiming")
    type: Optional[CreditGrantType] = None
    recurrence_config: Optional[RecurrenceConfig] = Field(default=None, alias="recurrenceConfig")
    __properties: ClassVar[List[str]] = ["id", "displayName", "name", "tag", "grantDetails", "rateDetails", "invoiceTiming", "type", "recurrenceConfig"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreditGrantRateCard from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of grant_details
        if self.grant_details:
            _dict['grantDetails'] = self.grant_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of rate_details
        if self.rate_details:
            _dict['rateDetails'] = self.rate_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of recurrence_config
        if self.recurrence_config:
            _dict['recurrenceConfig'] = self.recurrence_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreditGrantRateCard from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "displayName": obj.get("displayName"),
            "name": obj.get("name"),
            "tag": obj.get("tag"),
            "grantDetails": GrantDetails.from_dict(obj["grantDetails"]) if obj.get("grantDetails") is not None else None,
            "rateDetails": CreditRateDetails.from_dict(obj["rateDetails"]) if obj.get("rateDetails") is not None else None,
            "invoiceTiming": obj.get("invoiceTiming"),
            "type": obj.get("type"),
            "recurrenceConfig": RecurrenceConfig.from_dict(obj["recurrenceConfig"]) if obj.get("recurrenceConfig") is not None else None
        })
        return _obj


