# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from togai_client.models.currency_slab_rate_detail import CurrencySlabRateDetail
from togai_client.models.pricing_model import PricingModel
from typing import Optional, Set
from typing_extensions import Self

class CreditRateDetails(BaseModel):
    """
    Amount to be credited
    """ # noqa: E501
    pricing_model: PricingModel = Field(alias="pricingModel")
    currency_slab_rate_details: List[CurrencySlabRateDetail] = Field(alias="currencySlabRateDetails")
    __properties: ClassVar[List[str]] = ["pricingModel", "currencySlabRateDetails"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreditRateDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in currency_slab_rate_details (list)
        _items = []
        if self.currency_slab_rate_details:
            for _item_currency_slab_rate_details in self.currency_slab_rate_details:
                if _item_currency_slab_rate_details:
                    _items.append(_item_currency_slab_rate_details.to_dict())
            _dict['currencySlabRateDetails'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreditRateDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pricingModel": obj.get("pricingModel"),
            "currencySlabRateDetails": [CurrencySlabRateDetail.from_dict(_item) for _item in obj["currencySlabRateDetails"]] if obj.get("currencySlabRateDetails") is not None else None
        })
        return _obj


