# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from togai_client.models.slab_detail import SlabDetail
from typing import Optional, Set
from typing_extensions import Self

class CurrencySlabRateDetail(BaseModel):
    """
    The association of a currency along with its slab detail
    """ # noqa: E501
    currency: StrictStr
    credit_amount: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="The amount of credit that needs to be credited", alias="creditAmount")
    slab_details: List[SlabDetail] = Field(alias="slabDetails")
    rate_config: Optional[Dict[str, StrictStr]] = Field(default=None, alias="rateConfig")
    __properties: ClassVar[List[str]] = ["currency", "creditAmount", "slabDetails", "rateConfig"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CurrencySlabRateDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in slab_details (list)
        _items = []
        if self.slab_details:
            for _item_slab_details in self.slab_details:
                if _item_slab_details:
                    _items.append(_item_slab_details.to_dict())
            _dict['slabDetails'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CurrencySlabRateDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "currency": obj.get("currency"),
            "creditAmount": obj.get("creditAmount"),
            "slabDetails": [SlabDetail.from_dict(_item) for _item in obj["slabDetails"]] if obj.get("slabDetails") is not None else None,
            "rateConfig": obj.get("rateConfig")
        })
        return _obj


