# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from togai_client.models.event_schemas_for_feature import EventSchemasForFeature
from typing import Optional, Set
from typing_extensions import Self

class Feature(BaseModel):
    """
    Represents a Feature
    """ # noqa: E501
    id: StrictStr
    name: StrictStr
    billable_name: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, alias="billableName")
    display_name: Annotated[str, Field(strict=True, max_length=255)] = Field(description="Display name of feature. This is an auto-generated field which contains billableName of feature. If billableName is not provided, name will be used as display name. ", alias="displayName")
    schema_associations: Annotated[List[EventSchemasForFeature], Field(max_length=50)] = Field(description="Association of a feature with event_schemas", alias="schemaAssociations")
    created_at: datetime = Field(alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    __properties: ClassVar[List[str]] = ["id", "name", "billableName", "displayName", "schemaAssociations", "createdAt", "updatedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Feature from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in schema_associations (list)
        _items = []
        if self.schema_associations:
            for _item_schema_associations in self.schema_associations:
                if _item_schema_associations:
                    _items.append(_item_schema_associations.to_dict())
            _dict['schemaAssociations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Feature from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "billableName": obj.get("billableName"),
            "displayName": obj.get("displayName"),
            "schemaAssociations": [EventSchemasForFeature.from_dict(_item) for _item in obj["schemaAssociations"]] if obj.get("schemaAssociations") is not None else None,
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt")
        })
        return _obj


