# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetCustomerPortalDelegateTokenRequest(BaseModel):
    """
    Request to get delegate token for customer portal
    """ # noqa: E501
    customer_id: StrictStr = Field(description="Identifier of the customer", alias="customerId")
    account_ids: Optional[List[StrictStr]] = Field(default=None, description="Identifier of the accounts under the customer for which access is requested. Maximum of 5 account ids can be provided ", alias="accountIds")
    all_accounts_access: Optional[StrictBool] = Field(default=None, description="Flag to specify if access for every account under the customer is required", alias="allAccountsAccess")
    expiry: Optional[StrictInt] = Field(default=None, description="Expiry in seconds from the time of generation.  If not provided, generated token will have the expiry of the token used for requesting. ")
    __properties: ClassVar[List[str]] = ["customerId", "accountIds", "allAccountsAccess", "expiry"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCustomerPortalDelegateTokenRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCustomerPortalDelegateTokenRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customerId": obj.get("customerId"),
            "accountIds": obj.get("accountIds"),
            "allAccountsAccess": obj.get("allAccountsAccess"),
            "expiry": obj.get("expiry")
        })
        return _obj


