# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetJobResponse(BaseModel):
    """
    GetJobResponse
    """ # noqa: E501
    id: StrictStr
    type: StrictStr
    settled_at: Optional[datetime] = Field(default=None, alias="settledAt")
    updated_at: datetime = Field(alias="updatedAt")
    status: StrictStr
    total_job_entries: StrictInt = Field(alias="totalJobEntries")
    pending_job_entries: StrictInt = Field(alias="pendingJobEntries")
    failed_job_entries: StrictInt = Field(alias="failedJobEntries")
    completed_job_entries: StrictInt = Field(alias="completedJobEntries")
    metadata: Optional[Dict[str, StrictStr]] = None
    __properties: ClassVar[List[str]] = ["id", "type", "settledAt", "updatedAt", "status", "totalJobEntries", "pendingJobEntries", "failedJobEntries", "completedJobEntries", "metadata"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['PRICE_PLAN', 'EVENT_CORRECTIONS', 'BILL_RUN']):
            raise ValueError("must be one of enum values ('PRICE_PLAN', 'EVENT_CORRECTIONS', 'BILL_RUN')")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['SCHEDULED', 'PENDING', 'INITIALIZED', 'WAITING_FOR_CONFIRMATION', 'IN_PROGRESS', 'COMPLETED', 'FAILED', 'CANCELLED']):
            raise ValueError("must be one of enum values ('SCHEDULED', 'PENDING', 'INITIALIZED', 'WAITING_FOR_CONFIRMATION', 'IN_PROGRESS', 'COMPLETED', 'FAILED', 'CANCELLED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetJobResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetJobResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "settledAt": obj.get("settledAt"),
            "updatedAt": obj.get("updatedAt"),
            "status": obj.get("status"),
            "totalJobEntries": obj.get("totalJobEntries"),
            "pendingJobEntries": obj.get("pendingJobEntries"),
            "failedJobEntries": obj.get("failedJobEntries"),
            "completedJobEntries": obj.get("completedJobEntries"),
            "metadata": obj.get("metadata")
        })
        return _obj


