# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from togai_client.models.metric_data_points_grouped_by import MetricDataPointsGroupedBy
from typing import Optional, Set
from typing_extensions import Self

class MetricDataPoints(BaseModel):
    """
    MetricDataPoints
    """ # noqa: E501
    grouped_by: Optional[MetricDataPointsGroupedBy] = Field(default=None, alias="groupedBy")
    timestamps: Annotated[List[datetime], Field(max_length=300)]
    metric_values: Annotated[List[Union[StrictFloat, StrictInt]], Field(max_length=300)] = Field(alias="metricValues")
    __properties: ClassVar[List[str]] = ["groupedBy", "timestamps", "metricValues"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MetricDataPoints from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of grouped_by
        if self.grouped_by:
            _dict['groupedBy'] = self.grouped_by.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MetricDataPoints from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "groupedBy": MetricDataPointsGroupedBy.from_dict(obj["groupedBy"]) if obj.get("groupedBy") is not None else None,
            "timestamps": obj.get("timestamps"),
            "metricValues": obj.get("metricValues")
        })
        return _obj


