# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from togai_client.models.price_plan_details_override import PricePlanDetailsOverride
from togai_client.models.pricing_rule import PricingRule
from typing import Optional, Set
from typing_extensions import Self

class PlanOverride(BaseModel):
    """
    Represents effectiveness period and config of a price plan. i.e, price plan bound by time.
    """ # noqa: E501
    id: StrictStr
    price_plan_id: StrictStr = Field(alias="pricePlanId")
    price_plan_name: StrictStr = Field(alias="pricePlanName")
    price_plan_details_override: Optional[PricePlanDetailsOverride] = Field(default=None, alias="pricePlanDetailsOverride")
    pricing_rules_override: Optional[List[PricingRule]] = Field(default=None, alias="pricingRulesOverride")
    start_date: datetime = Field(alias="startDate")
    end_date: datetime = Field(alias="endDate")
    __properties: ClassVar[List[str]] = ["id", "pricePlanId", "pricePlanName", "pricePlanDetailsOverride", "pricingRulesOverride", "startDate", "endDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PlanOverride from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of price_plan_details_override
        if self.price_plan_details_override:
            _dict['pricePlanDetailsOverride'] = self.price_plan_details_override.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in pricing_rules_override (list)
        _items = []
        if self.pricing_rules_override:
            for _item_pricing_rules_override in self.pricing_rules_override:
                if _item_pricing_rules_override:
                    _items.append(_item_pricing_rules_override.to_dict())
            _dict['pricingRulesOverride'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PlanOverride from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "pricePlanId": obj.get("pricePlanId"),
            "pricePlanName": obj.get("pricePlanName"),
            "pricePlanDetailsOverride": PricePlanDetailsOverride.from_dict(obj["pricePlanDetailsOverride"]) if obj.get("pricePlanDetailsOverride") is not None else None,
            "pricingRulesOverride": [PricingRule.from_dict(_item) for _item in obj["pricingRulesOverride"]] if obj.get("pricingRulesOverride") is not None else None,
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate")
        })
        return _obj


