# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from togai_client.models.price_plan_type import PricePlanType
from togai_client.models.pricing_schedule import PricingSchedule
from typing import Optional, Set
from typing_extensions import Self

class PricePlan(BaseModel):
    """
    Price plan entity
    """ # noqa: E501
    id: StrictStr = Field(description="Price plan id")
    name: Annotated[str, Field(strict=True, max_length=50)] = Field(description="Name of the price plan")
    type: PricePlanType
    description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="Description of price plan")
    status: StrictStr = Field(description="Status of Price plan")
    pricing_schedule: List[PricingSchedule] = Field(alias="pricingSchedule")
    __properties: ClassVar[List[str]] = ["id", "name", "type", "description", "status", "pricingSchedule"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['DRAFT', 'ACTIVE', 'ARCHIVED']):
            raise ValueError("must be one of enum values ('DRAFT', 'ACTIVE', 'ARCHIVED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PricePlan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in pricing_schedule (list)
        _items = []
        if self.pricing_schedule:
            for _item_pricing_schedule in self.pricing_schedule:
                if _item_pricing_schedule:
                    _items.append(_item_pricing_schedule.to_dict())
            _dict['pricingSchedule'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PricePlan from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "type": obj.get("type"),
            "description": obj.get("description"),
            "status": obj.get("status"),
            "pricingSchedule": [PricingSchedule.from_dict(_item) for _item in obj["pricingSchedule"]] if obj.get("pricingSchedule") is not None else None
        })
        return _obj


