# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from togai_client.models.proration_config_custom_config import ProrationConfigCustomConfig
from togai_client.models.proration_config_lookup_cycle_config import ProrationConfigLookupCycleConfig
from typing import Optional, Set
from typing_extensions import Self

class ProrationConfig(BaseModel):
    """
    Configuration for getting the proration, if not provided no proration will be applied
    """ # noqa: E501
    mode: StrictStr = Field(description="Mode to get the proration - CUSTOM: Use the proration provided in the request - LOOKUP_CYCLE: Use the proration of a given account for the specified cycle ")
    custom_config: Optional[ProrationConfigCustomConfig] = Field(default=None, alias="customConfig")
    lookup_cycle_config: Optional[ProrationConfigLookupCycleConfig] = Field(default=None, alias="lookupCycleConfig")
    __properties: ClassVar[List[str]] = ["mode", "customConfig", "lookupCycleConfig"]

    @field_validator('mode')
    def mode_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['CUSTOM', 'LOOKUP_CYCLE']):
            raise ValueError("must be one of enum values ('CUSTOM', 'LOOKUP_CYCLE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProrationConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of custom_config
        if self.custom_config:
            _dict['customConfig'] = self.custom_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of lookup_cycle_config
        if self.lookup_cycle_config:
            _dict['lookupCycleConfig'] = self.lookup_cycle_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProrationConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "mode": obj.get("mode"),
            "customConfig": ProrationConfigCustomConfig.from_dict(obj["customConfig"]) if obj.get("customConfig") is not None else None,
            "lookupCycleConfig": ProrationConfigLookupCycleConfig.from_dict(obj["lookupCycleConfig"]) if obj.get("lookupCycleConfig") is not None else None
        })
        return _obj


