# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from togai_client.models.slab_revenue_with_metadata import SlabRevenueWithMetadata
from typing import Optional, Set
from typing_extensions import Self

class RevenueSummaryWithMetadata(BaseModel):
    """
    RevenueSummaryWithMetadata
    """ # noqa: E501
    revenue: Union[StrictFloat, StrictInt]
    revenue_summary: Optional[List[RevenueSummaryWithMetadata]] = Field(default=None, description="Field: revenue is computed for all rate cards Field: slabRevenues is supported for only usage/license Field: metadata is populated based on application of rateConfig('minimumRate', 'maximumRate') ", alias="revenueSummary")
    slab_revenues: Optional[List[SlabRevenueWithMetadata]] = Field(default=None, alias="slabRevenues")
    metadata: Optional[Dict[str, StrictStr]] = None
    __properties: ClassVar[List[str]] = ["revenue", "revenueSummary", "slabRevenues", "metadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RevenueSummaryWithMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in revenue_summary (list)
        _items = []
        if self.revenue_summary:
            for _item_revenue_summary in self.revenue_summary:
                if _item_revenue_summary:
                    _items.append(_item_revenue_summary.to_dict())
            _dict['revenueSummary'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in slab_revenues (list)
        _items = []
        if self.slab_revenues:
            for _item_slab_revenues in self.slab_revenues:
                if _item_slab_revenues:
                    _items.append(_item_slab_revenues.to_dict())
            _dict['slabRevenues'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RevenueSummaryWithMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "revenue": obj.get("revenue"),
            "revenueSummary": [RevenueSummaryWithMetadata.from_dict(_item) for _item in obj["revenueSummary"]] if obj.get("revenueSummary") is not None else None,
            "slabRevenues": [SlabRevenueWithMetadata.from_dict(_item) for _item in obj["slabRevenues"]] if obj.get("slabRevenues") is not None else None,
            "metadata": obj.get("metadata")
        })
        return _obj

# TODO: Rewrite to not use raise_errors
RevenueSummaryWithMetadata.model_rebuild(raise_errors=False)

