# coding: utf-8

"""
    Togai Apis

    APIs for Togai App

    The version of the OpenAPI document: 1.0
    Contact: engg@togai.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from togai_client.models.plan_override import PlanOverride
from typing import Optional, Set
from typing_extensions import Self

class UpdatePricingScheduleResponse(BaseModel):
    """
    UpdatePricingScheduleResponse
    """ # noqa: E501
    account_id: Annotated[str, Field(strict=True, max_length=50)] = Field(description="Identifier of the account", alias="accountId")
    account_name: StrictStr = Field(description="Name of the Account", alias="accountName")
    pricing_schedules: List[PlanOverride] = Field(alias="pricingSchedules")
    __properties: ClassVar[List[str]] = ["accountId", "accountName", "pricingSchedules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdatePricingScheduleResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in pricing_schedules (list)
        _items = []
        if self.pricing_schedules:
            for _item_pricing_schedules in self.pricing_schedules:
                if _item_pricing_schedules:
                    _items.append(_item_pricing_schedules.to_dict())
            _dict['pricingSchedules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdatePricingScheduleResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "accountName": obj.get("accountName"),
            "pricingSchedules": [PlanOverride.from_dict(_item) for _item in obj["pricingSchedules"]] if obj.get("pricingSchedules") is not None else None
        })
        return _obj


